# 
# If "?????????" then File - Reopen with Encoding... windows-1251
#
#   .. ,  
#     
#  .. 
#
#   "     "
# http://www.landscape.edu.ru/edu_help5_KiS.shtml
# /
#  4    "    R"
# http://www.landscape.edu.ru/edu_help4_R.shtml
#
#  1. "    R"
#   1.1    ,     
#   1.2    
#   1.3  
#
# ######################################################################
#   09.03.2016
# ######################################################################

# 1.1    ,     

#  (numerical vectors)
x <- c(174, 162, 188, 192, 165, 168, 172.5)
str(x)  #        
x[2]    #    
x[5]    #    
a = 1:7 #      1  7
b = seq(100, 700, 100)  #     100  700   100
c = rnorm(7) #      
c

2+2
log10(10)
log(x + 1)
sqrt(x)
d = b/2 + a^2 + c
d

#  (factor)   (ordered) 
s.id <- c("", "", "", "", "", "", "") #    
str(s.id)   #  (character)     
plot(s.id)  #      (Error...)

s.id <- factor(s.id) #      ,
str(s.id) 
plot(s.id)  #   
table(s.id) #       
s.id <- ordered(s.id, levels=c("","","","")) #     
s.id <- factor(s.id, ordered=TRUE, levels=c("","","","")) #  
plot(s.id)  #        
table(s.id) #     

#  
d <- data.frame(sid=s.id, sHCL=x, sA=c(60,65,70,65,70,55,90))
d
d$AHCL <- d$sHCL-d$sA #  "$" -      
d
#     [  -  ,  -  ]
d. <- d[d$sid == "",]      #  ,     
d. <- d[d$sid == "", 1:2]  #     
A. <- d$sA[d$sid == ""]    #    (),  

#   R
# ""             ==
# " "          !=
# ""            <
# ""            >
# "  " <=
# "  " >=
# " "      &
# " "    |
# " "     !

#   ()
library(car)  #  ,    recode()
var <- Recode(x, "80='1'; 90='2'; 100='3'")
var
var <- Recode(d$sid, "''='1';''='2';''='3'; ''='4'")
var

# 1.2     ( - )

setwd("D:/Dropbox/R") #    
data <- read.csv2("MET_points_2014.txt", header = TRUE, sep = ";", 
                    quote = "\"", dec = ".", fill = TRUE, 
                    comment.char = "", stringsAsFactors = FALSE) #   "\t"

View(data)    #   
str(data)     #    
head(data)    #   6  
summary(data) # , , , .    
summary(data$A) # , , , .   

#     
write.table(data, "data_new.txt", quote=FALSE)

#####################################################################################
# 1.3  

#  
par(mar=c(2, 2, 1.5, 0.2))  #      , 
plot(data$Xm, data$Ym, type="p", main="", xlab="", ylab="")
text(data$Xm, data$Ym, labels=data$sid, pos = 4, offset = 0.5)

plot(data$h0050, data$h001m, type="p", main="", xlab="", ylab="")

#     
coplot(data$h001m ~ data$h0050 | data$sid)

# example(points) #    

# 
hist(data$h001m, breaks=10, main="")
hist(data$h001m, breaks=10, main="", col = "red", density=10, labels = TRUE)
hist(data$h001m, breaks=11, main="", col = "lightblue", border = "darkgrey", labels = TRUE)

hist(data$h001m, breaks=11, freq = FALSE, main="", col = "lightblue", labels = FALSE)
lines(density(data$h001m, adjust=1), col = "red", lwd=3)
lines(density(data$h001m, adjust=0.5), col= "blue", lwd = 2)
rug(data$h001m)

plot(density(data$h001m, adjust=1), main="", col = "red", lwd=3) #add=TRUE
rug(data$h001m)

#   
par(mar=c(4, 4, 0.5, 0.2))  #      , 
qqnorm(data$h001m, main = "", xlab = " ",
       ylab = " ", plot.it = TRUE, datax = FALSE)
qqline(data$h001m, datax = FALSE, distribution = qnorm, probs = c(0.25, 0.75),
       qtype = 7, col="red")
#       ,      .

# install.packages('beeswarm', dep=TRUE) #     beeswarm
library("beeswarm") #   beeswarm   

par(mar=c(2, 2, 0.5, 0.2))      #      , 
boxplot(data$h001m)             #   
beeswarm(data$h001m, add=TRUE)  #     

boxplot(data$h0050, data$h001m) #    

boxplot(data$h001m ~ factor(data$sid))  #     ( )
data$sid <- ordered(data$sid, levels=c("","","","")) #     
plot(data$sid, data$h001m)      #      .  plot()
beeswarm(data$h001m ~ data$sid, method = "center", add=TRUE)  #     
#       method = "swarm", "hex", "square", "center"
# col = rainbow(4) -      
table(data$sid)   #    

#       
library(ggplot2)
dataSUB <- data[data$sid != "",]   #  ,       
p <- ggplot(dataSUB, aes(x = h001m)) 
(p <- p + geom_density(aes(fill = sid), alpha = 0.5))

#   -  -
install.packages('sm', dep=TRUE) #     sm
library(sm)
data(InsectSprays)
head(InsectSprays)
attach(InsectSprays)
#       
sm.density.compare(count, spray, lwd = 2, xlab=" ")
title(main="  ")
#     
colfill<-c(2:(2+length(levels(spray))))
#   ,    
legend(locator(1), levels(spray), fill=colfill)

# High Density Scatterplot with Binning
library(hexbin)
x <- rnorm(1000)
y <- rnorm(1000)
bin<-hexbin(x, y, xbins=50) 
plot(bin, main="Hexagonal Binning")
