# 
# If "?????????" then File - Reopen with Encoding... windows-1251
#
#   .. ,  
#     
#  .. 
#
#   "     "
# http://www.landscape.edu.ru/edu_help5_KiS.shtml
# /
#  4    "    R"
# http://www.landscape.edu.ru/edu_help4_R.shtml
# 
#  2. "    R" 
# 
# 
#  1.1    ,     
#  1.2    
#  1.3  
#
# ######################################################################
#   09.03.2016
# ######################################################################

setwd("D:/Dropbox/R") #    
data <- read.csv2("MET_points_2014.txt", header = TRUE, sep = "\t", dec = ".", fill = TRUE, 
                  comment.char = "", stringsAsFactors = FALSE) #   "\t"

View(data)    #   
str(data)     #    
head(data)    #   6  
summary(data) # , , , .    
summary(data$A) # , , , .   


# 2.4  
#    (0)       (p-value)
#      (.   )
#    0.95,  p-value < 0.05,    H0   1

# H0:           
boxplot(data$h001m ~ factor(data$sid)) 
data$sid <- ordered(data$sid, levels=c("","","","")) #     
boxplot(data$h001m ~ factor(data$sid)) 
table(data$sid)   #    , 
#       10 (30)  

#          0  
x <- rnorm(100, 0) #      
hist(x, breaks=11, freq = FALSE, main="", col = "lightblue", labels = FALSE)
lines(density(x, adjust=1), col = "red", lwd=3)
rug(x)
qqnorm(x, main = "", xlab = " ",
       ylab = " ", plot.it = TRUE, datax = FALSE)
qqline(x, datax = FALSE, distribution = qnorm, probs = c(0.25, 0.75),
       qtype = 7, col="red")

shapiro.test(x)        # 0:     (-) 
ks.test(x, "pnorm")    # 0:     (-)
shapiro.test(rnorm(100, mean = 5, sd = 3))

h001m. <- data$h001m[data$sid == ""] #   
shapiro.test(h001m.)        # 0:     (-) 
ks.test(h001m., "pnorm")    # 0:     (-)

h001m. <- data$h001m[data$sid == ""] #   
shapiro.test(h001m.)        # 0:     (-) 
ks.test(h001m., "pnorm")    # 0:     (-)

h001m. <- data$h001m[data$sid == ""] #    
shapiro.test(h001m.)        # 0:     (-) 
ks.test(h001m., "pnorm")    # 0:     (-)

# 0:      ( )
t.test(h001m., mu=mean(h001m.)) 
t.test(h001m., mu=mean(h001m.))
t.test(h001m., mu=mean(h001m.))

#     
#     ,  -   (   )
t.test(h001m., h001m., conf.level = 0.95, paired=FALSE) #     :

oneway.test(data$h001m ~ data$sid) #   
pairwise.t.test(data$h001m, data$sid, p.adj="bonferroni") #    p-value

#   -   ( ):
wilcox.test(h001m., h001m., paired=TRUE) #    
kruskal.test(list(h001m., h001m.))       #    
kruskal.test(list(h001m., h001m.))       #    
#:    0.95          (~  2 /)

##########################################################################
#       
##########################################################################

#         
dataN <- data.frame(var1=rnorm(200),
                    var2=rnorm(200))
dataN
str(dataN)

par(mar=c(2, 2, 1.5, 0.2)) #      
hist(dataN$var1, breaks=10, main="")
hist(dataN$var2, breaks=10, main="")
hist(dataN$var1, breaks=10, main="", col="lightblue")
hist(dataN$var2, breaks=10, main="", col="lightgreen", add=TRUE)

#   
qqnorm(dataN$var1, main = "Normal Q-Q Plot", xlab = "Theoretical Quantiles",
       ylab = "Sample Quantiles", plot.it = TRUE, datax = FALSE)
qqline(dataN$var1, datax = FALSE, distribution = qnorm, probs = c(0.25, 0.75),
       qtype = 7, col="red")
#       ,      .

t.test(dataN$var1, mu=mean(dataN$var1)) # 0:      ( )
t.test(dataN$var2, mu=mean(dataN$var1)) # 0:      ( )
shapiro.test(dataN$var1) # 0:    
shapiro.test(dataN$var2) # 0:    

dataN$var3 <- dataN$var2 + 0.5
boxplot(dataN$var1, dataN$var2)
boxplot(dataN$var1, dataN$var3)

#     ( )   :
t.test(dataN$var1, dataN$var2, conf.level = 0.95, paired=FALSE)
t.test(dataN$var1, dataN$var3, conf.level = 0.95, paired=FALSE)

#     ( ):
wilcox.test(dataN$var1, dataN$var2, paired=TRUE) #    
kruskal.test(list(dataN$var1, dataN$var2))       #    

#  p-value < 0.05,     .

###################################################################################
#  3.     
###################################################################################

par(mar=c(2, 2, 1.5, 0.2))  #      , 
plot(data$h0050, data$h001m, type="p", main="", xlab="", ylab="")

#       ?
# 1.  ,   [-1;1]

cor(data$h0050, data$h001m)
cor.test(data$h0050, data$h001m) #    -  0, data$h001m) # 0:   = 0

plot(5:15, c(7:17), main="", xlab="", ylab="")
cor(5:15, c(7:17))

plot(5:15, c(-7:-17), main="", xlab="", ylab="")
cor(5:15, c(-7:-17))

plot(5:15, c(7:15, 23, 20), main="", xlab="", ylab="")
cor(5:15, c(7:15, 23, 20))
cor(5:15, c(7:15, 23, 20), method="spearman") #     -  

plot(5:15, log(5:15), main="", xlab="", ylab="")
cor(5:15, log(5:15))
cor(5:15, log(5:15), method="spearman")

plot(data$h0050, data$h001m, type="p", main="", xlab="", ylab="")
cor(data$h0050, data$h001m)

str(data)
data[,12:21]                 #   :   - ,  - 
data[data$sid=="", 12:21]  #   :   - ,  - 
pairs(data[ ,12:21], pch=21) #  
cor(data[ ,12:21])           #   
symnum(cor(data[ ,12:21]))   #    

# heatmap -    
cor.l <- cor(data[ ,12:21])   
image(1:ncol(cor.l), 1:nrow(cor.l), cor.l, col=heat.colors(22), axes=FALSE, xlab="", ylab="")
axis(1, at=1:ncol(cor.l), labels=abbreviate(colnames(cor.l)))
axis(2, at=1:nrow(cor.l), labels=abbreviate(rownames(cor.l)), las = 2)

#       
#install.packages('ellipse', dep=TRUE) #     beeswarm
library(ellipse)
cor.l <- cor(data[ ,12:21])   #       
colnames(cor.l) <- abbreviate(colnames(cor.l))
rownames(cor.l) <- abbreviate(rownames(cor.l))
plotcorr(cor.l, type="lower", mar=c(0,0,0,0))

#      [NA]:
# use = "all.obs"               -          ( )
# use = "complete.obs"          -    ,      
# use = "pairwise.complete.obs" -       ( N !)
# cor(data[ ,8:17], use = "pairwise.complete.obs")

# 2.   y = b0 + b1*x,   R ?? [0;1]
#     lm():

lm.hum50100 <- lm(formula = data$h001m ~ data$h0050)
lm.hum50100   #   :

#   :
b0 <- lm.hum50100$coefficient[1]
b1 <- lm.hum50100$coefficient[2]
x1 <- min(data$h0050)
x2 <- max(data$h0050)
x <- seq(from = x1, to = x2, length.out =20)
y <- b0 + b1*x
plot(data$h0050, data$h001m, main="", xlab="", ylab="")
grid()
lines(x, y, type="l", col="red") #   

summary(lm.hum50100)

###################################################################################
#  4.  
###################################################################################
#  ()    

library(cluster) 

#     (  )
sand <- c(16, 5, 25, 6, 3)   #  
clay <- c(8, 15, 17, 25, 31) #  
s <- data.frame(clay, sand)  #     
s
par(mar=c(4, 4, 1.5, 0.2))  #      , 
plot(sand ~ clay, data=s, type='n', xlab='% ', ylab='% ')
text(s$clay, s$sand, row.names(s), font=2) #      

#       
d <- daisy(s, metric="euclid")
d 

h <- hclust(d, method="ward.D") #  
plot(h, main="")                     #  

par(mfcol=c(1,2), mar=c(4.5,4,1,1)) #          
plot(sand ~ clay, data=s, type='n', xlab='% ', ylab='% ')
grid()
text(s$clay, s$sand, row.names(s), font=2)      #      
plot(h, main="", xlab=' ') #  

N <- 3 
eq.k <- kmeans(s, N) #    N  (k-means)
eq.k
plot(sand ~ clay, data=s, type='p', col=as.numeric(eq.k$cluster), xlab='% ', ylab='% ')
text(s$clay, s$sand, row.names(s), col=as.numeric(eq.k$cluster), font=2, pos = 4, offset=0.5) 
plot(h, main="", xlab='% ')      #  

#################################################################
#      ()    (HCL)
data[, 4:5] #          

par(mar=c(4, 4, 1.5, 0.2))  #      , 
plot(data$A, data$HCl, type="p", col=factor(data$sid), main="", xlab="  , ", ylab=" , ")

#      :  -  -  - ,
#        HCl

data.d <- daisy(data[ , 4:5], metric="euclid") # metric="gower"
data.d

data.h <- hclust(data.d, method="ward.D") #   "single", "complete", "average", "mcquitty", "median", "centroid"

par(mfcol=c(1,1), mar=c(0.5,4,0.5,0.2)) #      
plot(data.h)                   #  

N <- 3
eq.k <- kmeans(data[ ,4:5], N) #    N  (k-means)
eq.k
plot(data$A, data$HCl, type="p", main="", col=as.numeric(eq.k$cluster), xlab="  , ", ylab=" , ")

#         HCl, 
# ..   HCl >>  
summary(data[ ,4:5])
data.scale <- scale(data[ ,4:5])
summary(data.scale)
data.d <- daisy(data.scale, metric="euclid") 
data.h <- hclust(data.d, method="ward.D")
par(mfcol=c(1,1), mar=c(4,4,0.5,0.2))
plot(data.h)
N <- 5
eq.k <- kmeans(data.scale, N)
eq.k
plot(data$A, data$HCl, type="p", main="", col=as.numeric(eq.k$cluster), xlab="  , ", ylab=" , ")

#       .   
#     :
# 1)   , 
# 2)      , . > help(daisy)
# 3)   /, . > help(hclust)
#    /          scale()
#  (metric) -        
# metric="euclid"     -     (),  . 
# metric="manhattan"  -   ()       
# metric="gower"      -   ( )
#   

###################################################################################
#  5.  
###################################################################################
#  ()    
install.packages('ggplot2', dep=TRUE) #     ggplot2
library(ggplot2)
library(MASS)

par(mar=c(4, 4, 1.5, 0.2))  #      , 
plot(data$TPI15, data$TPI70, type="p", col=factor(data$sid), main="", xlab="  , ", ylab=" , ")
data$sid <- ordered(data$sid, levels=c("","","","")) #    

z <- lda(sid ~ TPI15 + TPI70, data=data)
z

data.lda.p<- predict(z,newdata=data[,c(25,31)])$class
table(data.lda.p, data$sid)

xyplot(LD1 ~ LD2, data=z, groups=class)

